<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item prop="year"  label="年份">
        <el-input v-model="form.year" placeholder="请输入年份"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['area:TOTEXPAREA:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['area:TOTEXPAREA:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['area:TOTEXPAREA:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['area:TOTEXPAREA:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table :data="TOTEXPAREAList" @selection-change="handleSelectionChange">

      <el-table-column type="selection" width="55" align="center" />

      <el-table-column label="年份" align="center" prop="year" />
      <el-table-column label="进出口" align="center" prop="imExport"/>
      <el-table-column label="同比值" align="center" prop="growthRate"/>


      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['area:TOTEXPAREA:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['area:TOTEXPAREA:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改自治区数据对话框 -->
    <el-dialog :title="title" :visible.sync="open" :close-on-click-modal="false" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item prop="year" label-width="120px" label="年份">
          <el-input v-model="form.year" placeholder="请输入年份"></el-input>
        </el-form-item>

        <el-form-item prop="imExport" label-width="120px" label="区进出口总值">
          <el-input
            v-model="form.imExport"
            placeholder="请输入区进出口总值"
          ></el-input>
        </el-form-item>
        <el-form-item prop="growthRate" label-width="120px" label="同比">
          <el-input v-model="form.growthRate" placeholder="请输入同比值"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listTOTEXPAREA, getTOTEXPAREA, delTOTEXPAREA, addTOTEXPAREA, updateTOTEXPAREA } from "@/api/totexp/TOTEXPAREA";

export default {
  name: "TOTEXPAREA",
  data() {
    return {
      // 根路径
      baseURL: process.env.VUE_APP_BASE_API,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 自治区数据表格数据
      TOTEXPAREAList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 近年年份列表
      nearYearList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        id: null,
        imExport: null,
        growthRate: null,
        year: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        imExport: [
          { required: true, message: "进出口不能为空", trigger: "blur" }
        ],
        growthRate: [
          { required: true, message: "同比值不能为空", trigger: "blur" },
          { trigger: "blur", validator: this.validatorFloatNum },
        ],
        year: [
          { required: true, message: "年份不能为空", trigger: "blur" },
          { trigger: "blur", validator: this.validatorFloatNum },
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询自治区数据列表 */
    getList() {
      this.loading = true;
      listTOTEXPAREA(this.queryParams).then(response => {
        this.TOTEXPAREAList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        imExport: null,
        growthRate: null,
        year: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加自治区数据";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getTOTEXPAREA(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改自治区数据";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateTOTEXPAREA(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTOTEXPAREA(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除自治区数据编号为"' + ids + '"的数据项？').then(function() {
        return delTOTEXPAREA(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('area/TOTEXPAREA/export', {
        ...this.queryParams
      }, `TOTEXPAREA_${new Date().getTime()}.xlsx`)
    },
    // 校验参数
    validatorFloatNum(rule, value, callback) {
      let reg = /^[+-]?(0|([1-9]\d*))(\.\d+)?$/g;
      if (!reg.test(value)) {
        callback(new Error("请输入数字和正确格式的数字"));
      } else if (value.split(".").length > 2) {
        callback(new Error("请输入正确格式的数字")); //防止输入多个小数点
      } else {
        callback();
      }
      // else if (value.indexOf('.') != -1 && value.split('.')[1].length > 6) {
      //     callback(new Error('最多只能输入两位小数')); //小数点后两位
      //   }
    },
  }
};
</script>
